"use strict";

const ComponentDef = require("../../../runtime/components/ComponentDef");

var FLAG_WILL_RERENDER_IN_BROWSER = 1;
// var FLAG_HAS_RENDER_BODY = 2;
var FLAG_OLD_HYDRATE_NO_CREATE = 8;

module.exports = function beginComponent(componentsContext, component, key, ownerComponentDef, isSplitComponent, isImplicitComponent, existingComponentDef) {
  var componentId = component.id;

  // existingComponentDef is only here to allow binding a conditional
  // widget.  It should be removed when the legacy compat layer is removed.
  var componentDef = existingComponentDef || (componentsContext.q_ = new ComponentDef(component, componentId, componentsContext));

  var ownerIsRenderBoundary = ownerComponentDef && ownerComponentDef.w_;
  var ownerWillRerender = ownerComponentDef && ownerComponentDef.x_ & FLAG_WILL_RERENDER_IN_BROWSER;
  // On the server
  if (!componentsContext.y_ && ownerWillRerender) {
    componentDef.x_ |= FLAG_WILL_RERENDER_IN_BROWSER;
    componentDef._wrr = true;
    return componentDef;
  }

  if (isImplicitComponent === true) {
    // We don't mount implicit components rendered on the server
    // unless the implicit component is nested within a UI component
    // that will re-render in the browser
    return componentDef;
  }

  componentsContext.t_.push(componentDef);

  let out = componentsContext.u_;
  let runtimeId = out.global.runtimeId;

  componentDef.w_ = true;
  componentDef.z_ = componentsContext.y_;

  if (isSplitComponent === false && out.global.noBrowserRerender !== true) {
    componentDef.x_ |= FLAG_WILL_RERENDER_IN_BROWSER;
    componentDef._wrr = true;
    componentsContext.y_ = false;
  }

  if (out.global.oldHydrateNoCreate === true) {
    componentDef.x_ |= FLAG_OLD_HYDRATE_NO_CREATE;
  }

  if ((ownerIsRenderBoundary || ownerWillRerender) && key != null) {
    out.w("<!--" + runtimeId + "^" + componentId + " " + ownerComponentDef.id + " " + key + "-->");
  } else {
    out.w("<!--" + runtimeId + "#" + componentId + "-->");
  }

  return componentDef;
};